Unit      Int_0405; Interface
{ ------------------------------------------------------------------------- }
{ Support module for units optimized by Sally Peephole Optimizer.           }
{ Copyright 1993 by Sally I/S.                                              }
{                                                                           }
{ Private individuals may distribute compiled versions of this unit as part }
{ of their own software provided that the copyright messages are left       }
{ intact.                                                                   }
{                                                                           }
{ Install handlers for exceptions 04 and 05. These are generated by the     }
{ IntO and Bound instructions. As IBM used 05 for print screen despite its  }
{ being reserved by Intel we check for the origin of the interrupt -- it's  }
{ fool proof but it's not damn fool proof.                                  }
{ ------------------------------------------------------------------------- }
{$R-,S-,I-,Q-,O-,F-,G-,A+}

Implementation

Uses      Dos;
{ ------------------------------------------------------------------------- }
Var       Halterror  : Pointer;
          SaveInt04  : Pointer;
          SaveInt05  : Pointer;
          SaveExit   : Pointer;
{ ------------------------------------------------------------------------- }
Procedure Int04; Far; Assembler;
Asm
          Jmp    @@0
  @@1:    Db     0Eah
          Dd     0
  @@0:    Jno    @@1
          Push   Ax
          Mov    Ax,Ds
          Cmp    Ax,Seg @Data
          Pop    Ax
          Jne    @@1
          Mov    Ax,215
          Jmp    [Dword Ptr Halterror]
End;
{ ------------------------------------------------------------------------- }
Procedure Int05; Far; Assembler;
Asm
          Jmp    @@0
  @@1:    Db     0Eah
          Dd     0
  @@0:    Push   Ax
          Mov    Ax,Ds
          Cmp    Ax,Seg @Data
          Pop    Ax
          Jne    @@1
          Push   Bp
          Mov    Bp,Sp
          Lds    Bp,[Bp+2]
          Cmp    [Word Ptr Ds:Bp],$622E          { Bound Ax,[Cs:....] }
          Je     @@5
          Cmp    [Word Ptr Ds:Bp],$2E66          { Op32, Cs: }
          Je     @@3
          Cmp    [Word Ptr Ds:Bp],$662E          { Cs:, Op32 }
          Jne    @@2
  @@3:    Cmp    [Word Ptr Ds:Bp+2],$0662        { Bound Eax,[....] }
          Jne    @@2
  @@5:    Mov    Bp,Seg @Data
          Mov    Ds,Bp
          Pop    Bp
          Mov    Ax,201
          Jmp    [Dword Ptr Halterror]
  @@2:    Mov    Bp,Seg @Data
          Mov    Ds,Bp
          Pop    Bp
          Jmp    @@1
End;
{ ------------------------------------------------------------------------- }
Procedure NewExit; Far;
Begin
  ExitProc:=SaveExit;
  SetIntVec($04,SaveInt04);
  SetIntVec($05,SaveInt05);
End;
{ ------------------------------------------------------------------------- }
Procedure Install;
Var       Where     : Pointer;
          Copyright : String;
Begin
  Copyright:='Portions copyright 1993 by Sally I/S'#13#10;

  GetIntVec($04,SaveInt04);            { Save state }
  GetIntVec($05,SaveInt05);
  SaveExit:=ExitProc;
  ExitProc:=@NewExit;

  Where:=@Int04;                       { Place handlers for easy access. }
  Inc(Word(Where),3);
  Pointer(Where^):=SaveInt04;
  Where:=@Int05;
  Inc(Word(Where),3);
  Pointer(Where^):=SaveInt05;

  GetIntVec($00,Where);                { Dirty hack to find HaltError. }
  Inc(Word(Where),3);
  Halterror:=Where;

  SetIntVec($04,@Int04);
  SetIntVec($05,@Int05);
End;
{ ------------------------------------------------------------------------- }
Procedure Zeroextend_Registers;
Const     Op32 = $66;
Begin
  If Test8086>=2 Then
    Asm    Db Op32 ; And Sp,$FFFF ; Dw 0
           Db Op32 ; And Bp,$FFFF ; Dw 0
    End;
End;
{ ------------------------------------------------------------------------- }
Begin
  Zeroextend_Registers;
  Install;
End.
